
     /********************************************************************/
     /* AUTHOR:  Jim Rickman                                             */
     /* DATE:    October 1991                                            */
     /* PROGRAM: base.c                                                  */
     /*------------------------------------------------------------------*/
     /* PURPOSE: This Program is a Number Base converter.  It converts a */
     /*          User-specified Number of a specified Base to all other  */
     /*          supported Bases (2-16).                                 */
     /*          The Program will handle Numbers as large as 4294967295, */
     /*          Base 10.  Numbers larger than this will yield erroneous */
     /*          results.                                                */
     /*------------------------------------------------------------------*/
     /* COMPILE: This program was compiled using Microsoft C, ver 6.0.   */
     /*------------------------------------------------------------------*/
     /* This Program is donated to the Public Domain.                    */
     /********************************************************************/


/*---------------*/
/* Include Files */
/*---------------*/ 
#include <stdio.h>
#include <graph.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>


/*------------*/
/* Definition */
/*------------*/
#define FIELD 32               /* Maximum Number of Digits                 */

/*------------------*/
/* Global Variables */
/*------------------*/
char buffer[250];
char maximum[32];
char msg1[19];                 /* Info Line 1 of Message Area, 16 chars    */
char msg2[19];                 /* Info Line 2 of Message Area, 16 chars    */
char msg3[19];                 /* Info Line 3 of Message Area, 16 chars    */
char msg4[19];                 /* Info Line 4 of Message Area, 16 chars    */
char msg5[19];                 /* Info Line 5 of Message Area, 16 chars    */
unsigned long int decimal;     /* To handle Numbers as large as 4294967295 */
int base;
int o_base;
int nbase;
int lines;
int number_digits;
int err_flag;
struct videoconfig vc;         /* Video Config Information                 */


/*------------------*/
/* The Main Routine */
/*------------------*/
main()
{
     char string[3];
     char ch;
     int j, x;

     /*------------------------------------------------------*/
     /* Turn off the cursor and paint the entire screen blue */
     /*------------------------------------------------------*/
     _displaycursor (_GCURSOROFF);
     _setbkcolor (1);  _clearscreen (_GCLEARSCREEN);

     /*----------------------------------*/
     /* Paint the Base Conversion Window */
     /*----------------------------------*/
     pnt_output ();  pnt_new ();  err_flag = 0;

     /*-----------------*/
     /* Get Number Base */
     /*-----------------*/
     GET_BASE:  x = 0;
     sprintf (buffer, "  ");  _settextposition (7, 19);  _setbkcolor (1);
     _settextcolor (15);  _outtext (buffer);
     _settextposition (7, 19);
     for (j=0; j<2; j++)
     {
          x++;
          /*--------------------------*/
          /* Output substitute cursor */
          /*--------------------------*/
          sprintf (buffer, "_");  _settextposition (7, 18+x);
          _setbkcolor (1);  _settextcolor (31);  _outtext (buffer);
          while (!kbhit())
               DateTime ();
          /*----------*/
          /* Got it ! */
          /*----------*/
          ch = getch ();
          sprintf (buffer, "%c", ch);  _settextposition (7, 18+x);
          _setbkcolor (1);  _settextcolor (15);  _outtext (buffer);
          if ((string[j] = ch) == '\r')
               break;
          if (isdigit(string[j]) == 0)
               goto GET_BASE;
     }
     string[j] == '\0';
     base = atoi (string);
     if (base < 2  ||  base > 16)
     {
          putch ('\007');  err_flag = 1;
          strcpy (msg1, " Base Number is");
          strcpy (msg2, " INVALID.");
          strcpy (msg3, " This Program");
          strcpy (msg4, " supports Bases");
          strcpy (msg5, " 2 through 16.");
          out_message ();
          goto GET_BASE;
     }
     sprintf (buffer, "%2d", base);  _settextposition (7, 19);
     _setbkcolor (1);  _settextcolor (14);  _outtext (buffer);
     o_base = base;
     if (base == 2)
     {
          number_digits = 32;
          strcpy (maximum, "11111111111111111111111111111111");
     }
     if (base == 3)
     {
          number_digits = 21;
          strcpy (maximum, "102002022201221111210");
     }
     if (base == 4)
     {
          number_digits = 16;
          strcpy (maximum, "3333333333333333");
     }
     if (base == 5)
     {
          number_digits = 14;
          strcpy (maximum, "32244002423140");
     }
     if (base == 6)
     {
          number_digits = 13;
          strcpy (maximum, "1550104015503");
     }
     if (base == 7)
     {
          number_digits = 12;
          strcpy (maximum, "211301422353");
     }
     if (base == 8)
     {
          number_digits = 11;
          strcpy (maximum, "37777777777");
     }
     if (base == 9)
     {
          number_digits = 11;
          strcpy (maximum, "12068657453");
     }
     if (base == 10)
     {
          if (err_flag == 1)
          {
              message_area ();  err_flag = 0;
          }
          strcpy (maximum, "4294967295");
          sprintf (buffer, "%s", maximum);
          _settextposition (6, 37);  _setbkcolor (7);  _settextcolor (14);
          _outtext (buffer);
          Base10 ();  goto NEXT;
     }
     if (base == 11)
     {
          number_digits = 10;
          strcpy (maximum, "1904440553");
     }
     if (base == 12)
     {
          number_digits = 9;
          strcpy (maximum, "9BA461593");
     }
     if (base == 13)
     {
          number_digits = 9;
          strcpy (maximum, "535A79888");
     }
     if (base == 14)
     {
          number_digits = 9;
          strcpy (maximum, "2CA5B7463");
     }
     if (base == 15)
     {
          number_digits = 9;
          strcpy (maximum, "1A20DCD80");
     }
     if (base == 16)
     {
          number_digits = 8;
          strcpy (maximum, "FFFFFFFF");
     }
     if (base != 10)
     {
          if (err_flag == 1)
          {
              message_area ();  err_flag = 0;
          }
          GET_OTHER:
          sprintf (buffer, "%s", maximum);  _settextposition (6, 37);
          _setbkcolor (7);  _settextcolor (14);  _outtext (buffer);

          if ((Base2_16 ()) == 1)
          {
               message_area ();  out_message ();
               goto GET_OTHER;
          }
          else
          {
               if (err_flag == 1)
               {
                    message_area ();  err_flag = 0;
               }
               lines = 8;
               /*--------------------------------------------------------*/
               /* Loop to output conversions to Base Number 2 through 16 */
               /*--------------------------------------------------------*/
               for (base=2; base < 17; ++base)
               {
                    lines++;  output_bases ();
               }
          }
     }

     /*------------------------------------------*/
     /* Does User want to process more numbers ? */
     /*------------------------------------------*/
     NEXT:  message_area ();
     strcpy (msg1, " ");
     strcpy (msg2, "  More Numbers ?");
     strcpy (msg3, " ");
     strcpy (msg4, "  (y, n): ");
     strcpy (msg5, " ");
     out_message ();
     /*--------------------------*/
     /* Output substitute cursor */
     /*--------------------------*/
     sprintf (buffer, "_");  _settextposition (18, 23);
     _setbkcolor (3);  _settextcolor (31);  _outtext (buffer);
     /*-------------------------------------------------*/
     /* Display the current Date and Time while waiting */
     /* for the User to press 'n' or 'y'                */
     /*-------------------------------------------------*/
     while (!kbhit())
          DateTime ();
     /*----------*/
     /* Got it ! */
     /*----------*/
     ch = getch ();
     sprintf (buffer, "%c", ch);  _settextposition (18, 23);
     _settextcolor (14);  _outtext (buffer);
     /*----------------------*/
     /* Is it a 'y' or 'n' ? */
     /*----------------------*/
     if (ch == 'n'  ||  ch == 'N')
     {
          message_area ();
          strcpy (msg1, " ");
          strcpy (msg2, "  T H A N K");
          strcpy (msg3, " ");
          strcpy (msg4, "           Y O U");
          strcpy (msg5, " ");
          out_message ();
          _settextposition (24, 1);
          /*---------------------------------------*/
          /* Output the name of Program and Author */
          /*---------------------------------------*/
          sprintf (buffer, " Written by Jim Rickman ");
          _settextposition (24, 29);  _setbkcolor (7);  _settextcolor (9);
          _outtext (buffer);
          _displaycursor (_GCURSORON);
          exit (0);
     }
     else if (ch == 'y'  ||  ch == 'Y')
     {
          pnt_new ();  message_area ();  goto GET_BASE;
     }
     /*---------------------*/
     /* Nope, wait again... */
     /*---------------------*/
     else
          goto NEXT;
}


/*-------------------------------------*/
/* Base 10 Converter to Base 2 thru 16 */
/*-------------------------------------*/
Base10 ()
{
     char string[11];
     char ch;
     int j;

     GET_NUMBER:  pnt_number (base);
     /*-----------------------------------*/
     /* Get User-Specified Decimal Number */
     /*-----------------------------------*/
     for (j=0; j<10; j++)
     {
          sprintf (buffer, "_");  _settextposition (7, 37+j);
          _setbkcolor (1);  _settextcolor (31);  _outtext (buffer);
          /*-------------------------------------------------*/
          /* Display the current Date and Time while waiting */
          /* for the User to enter a digit                   */
          /*-------------------------------------------------*/
          while (!kbhit())
               DateTime ();
          ch = getch ();
          if ((string[j] = ch) == '\r')
               break;
          sprintf (buffer, "%c", ch);  _settextposition (7, 37+j);
          _setbkcolor (1);  _settextcolor (15);  _outtext (buffer);
          if (isdigit(string[j]) == 0)
          {
               putch ('\007');  err_flag = 1;  message_area ();
               strcpy (msg1, " Only digits are");
               strcpy (msg2, " allowed. Please");
               strcpy (msg3, " try again with");
               strcpy (msg4, " only digits as");
               strcpy (msg5, " input.");
               out_message ();
               sprintf (buffer, "%2d", base);  _settextposition (7, 19);
               _setbkcolor (1);  _settextcolor (14);  _outtext (buffer);
               sprintf (buffer, "%s", maximum);
               _settextposition (6, 37);  _outtext (buffer);  goto GET_NUMBER;
          }
     }
     string[j] = '\0';
     decimal = atol (string);
     if (decimal < 0  ||  decimal > 4294967295)
     {
          putch ('\007');  err_flag = 1;  message_area ();
          strcpy (msg1, " Must be between");
          strcpy (msg2, " 0 and 429496729.");
          strcpy (msg3, " Please try again");
          strcpy (msg4, " with another");
          strcpy (msg5, " within the range");
          out_message ();
          sprintf (buffer, "%2d", base);  _settextposition (7, 19);
          _setbkcolor (1);  _settextcolor (14);  _outtext (buffer);
          sprintf (buffer, "%s", maximum);
          _settextposition (6, 37);  _outtext (buffer);
          goto GET_NUMBER;
     }
     if (err_flag == 1)
     {
          message_area ();  err_flag = 0;
     }
     lines = 8;  o_base = 10;
     /*--------------------------------------------------------*/
     /* Loop to output conversions to Base Number 2 through 16 */
     /*--------------------------------------------------------*/
     for (base=2; base < 17; ++base)
     {
          lines++;  output_bases ();
     }
}


/*---------------------------------------------------------------*/
/* Perform actual conversions from Base 10 to equivalent numbers */
/* in Base 2 through 16 and then output the results              */
/*---------------------------------------------------------------*/
output_bases ()
{
     char c;
     unsigned long int ndecimal;
     int digit[FIELD], i, x;

     ndecimal = decimal;  nbase = base;

     _setbkcolor (2);  _settextcolor (15);
     /*--------------*/
     /* Math Section */
     /*--------------*/
     for (i=0; ndecimal != 0; i++)
     {
          /*------------------------------------------*/
          /* Do Division and save remainder, in order */
          /*------------------------------------------*/
          digit[i] = ndecimal % nbase;
          /*---------------------------------------*/
          /* Do Integer Division for the next pass */
          /*---------------------------------------*/
          ndecimal /= nbase;
          /*--------------------------------------*/
          /* Convert Integers to Character values */
          /*--------------------------------------*/
          if (10 <=digit[i] && digit[i]<=15)
               digit[i] += 'A' - 10;
          else
               digit[i] += '0';
     }

     x = i;
     if (nbase == o_base)
     {
          pnt_number (nbase);
          _settextposition (7, 37);  _settextcolor (14);
          i = x;
          while ( i > 0 )
          {
               --i;
               sprintf (buffer, "%c", digit[i]);  _outtext (buffer);
          }
     }
     _settextposition (lines, 37);
     i = x;
     while ( i > 0)
     {
          --i;
          /*--------------------------------------------------*/
          /* Print Digits in Reverse order, from Math Section */
          /*--------------------------------------------------*/
          sprintf (buffer, "%c", digit[i]);  _outtext (buffer);
     }
}


/*---------------------------------------------------*/
/* Base 2 thru Base 16 Conversion Routine to Base 10 */
/*---------------------------------------------------*/
Base2_16 ()
{
     char c;
     unsigned long int base_ten = 0;
     int digit[FIELD];
     int i, x;

     GET_NONDECIMAL:  pnt_number (base);
     /*---------------------------------------*/
     /* Get User-Specified Non-Decimal Number */
     /*---------------------------------------*/
     for (i = 1; i < number_digits+1; i++)
     {
          sprintf (buffer, "_");  _settextposition (7, (37+(i-1)));
          _setbkcolor (1);  _settextcolor (31);  _outtext (buffer);
          while (!kbhit())
               DateTime ();
          /*----------*/
          /* Got it ! */
          /*----------*/
          if ((c = getch ()) == '\r')
               break;
          sprintf (buffer, "%c", c);  _settextposition (7, (37+(i-1)));
          _setbkcolor (1);  _settextcolor (15);  _outtext (buffer);
          if ('a'<=c && c<='z')
               digit[i] = (c - 'a') + 10;
          else if ('A'<=c && c<='Z')
               digit[i] = (c - 'A') + 10;
          else if ('0'<=c && c<='9')
               digit[i] = (c - '0');
          else
          {
               putch ('\007');  err_flag = 1;
               strcpy (msg1, " ");
               strcpy (msg2, " Invalid char. was");
               strcpy (msg3, " detected.");
               strcpy (msg4, " Please try again.");
               strcpy (msg5, " ");
               return (1);
          }
          if (i == 32 && base ==  2)
               break;
          if (i == 21 && base ==  3)
               break;
          if (i == 16 && base ==  4)
               break;
          if (i == 14 && base ==  5)
               break;
          if (i == 13 && base ==  6)
               break;
          if (i == 12 && base ==  7)
               break;
          if (i == 11 && (base ==  8 || base == 9))
               break;
          if (i == 10 && base == 11)
               break;
          if (i ==  9 && (base == 12 || base == 13 || base == 14 || base == 15))
               break;
          if (i ==  8 && base == 16)
               break;
     }
     /*------------------------------*/
     /* 'x' holds the old value of i */
     /*------------------------------*/
     if (c == '\r')
     {
          digit[i] = '\0';
          i--;
     }
     x = i;
     for ( i = 1; i <= x; ++i)
     {
          /*--------------------------------------------*/
          /* Check that Number is valid for given range */
          /*--------------------------------------------*/
          if (digit[i] >= base)
          {
               putch ('\007');  err_flag = 1;
               strcpy (msg1, " ");
               strcpy (msg2, " Number is out of");
               strcpy (msg3, " range for Base.");
               strcpy (msg4, " Please try again.");
               strcpy (msg5, " ");
               return (1);
          }
          /*---------------------------------*/
          /* Multiply Base by positive value */
          /*---------------------------------*/
          base_ten *= base;
          /*--------------------*/
          /* Add Position Value */
          /*--------------------*/
          base_ten += digit[i];
          if (i == x)
               goto FINI_NONDECIMAL;
     }

     FINI_NONDECIMAL:  decimal = base_ten;
     if (decimal < 0  ||  decimal > 4294967295)
     {
          putch ('\007');  err_flag = 1;
          strcpy (msg1, " Must be between");
          strcpy (msg2, " 0 and 429496729.");
          strcpy (msg3, " Please enter a");
          strcpy (msg4, " number within");
          strcpy (msg5, " that range.");
          return (1);
     }

     /*--------------------------*/
     /* Decimal value must be OK */
     /*--------------------------*/
     return (0);
}


/*-----------------------------------------------------------------*/
/* Routine to Clear Input and Output Areas for new Base and Number */
/*-----------------------------------------------------------------*/
pnt_new ()
{
     /*--------------------------*/
     /* Clear the Message Window */
     /*--------------------------*/
     message_area ();

     sprintf (buffer, "                                 ");
     /*-----------------------------------------------*/
     /* Clear the Maximum and User-input Number areas */
     /*-----------------------------------------------*/
     _setbkcolor (7);
     _settextposition (6, 37);  _outtext (buffer);
     _settextposition (7, 37);  _outtext (buffer);
     /*---------------------------------------------*/
     /* Clear the number equivalences for Base 2-16 */
     /*---------------------------------------------*/
     sprintf (buffer, "                                  ");
     _setbkcolor (2);
     for (lines=9; lines<24; lines++)
     {
          _settextposition (lines, 36);  _outtext (buffer);
     }
}


/*----------------------------------------*/
/* Routine to clear the Number input area */
/*----------------------------------------*/
pnt_number (numbase)
int numbase;
{
     if (numbase == 16)
          sprintf (buffer, "        ");
     if (numbase == 12  ||  numbase == 13  ||  numbase == 14  ||  numbase == 15)
          sprintf (buffer, "         ");
     if (numbase == 10  ||  numbase == 11)
          sprintf (buffer, "          ");
     if (numbase ==  9  ||  numbase == 8)
          sprintf (buffer, "           ");
     if (numbase ==  7)
          sprintf (buffer, "            ");
     if (numbase ==  6)
          sprintf (buffer, "             ");
     if (numbase == 5)
          sprintf (buffer, "              ");
     if (numbase ==  4)
          sprintf (buffer, "                ");
     if (numbase ==  3)
          sprintf (buffer, "                     ");
     if (numbase ==  2)
          sprintf (buffer, "                                ");
     _settextposition (7, 37);  _setbkcolor (1);  _outtext (buffer);
     _settextposition (7, 37);
}


/*----------------------------------------------------*/
/* Routine to Paint the Base Number Conversion Window */
/*----------------------------------------------------*/
pnt_output ()
{
     int cnt;

     /*--------------------------------*/
     /* Draw the Borders of the Window */
     /*--------------------------------*/
     _setbkcolor (3);  _settextcolor (15);
     sprintf (buffer, "ͻ");
     _settextposition (3, 11);  _outtext (buffer);
     _setbkcolor (3);  _settextcolor (15);
     for (cnt=4; cnt<9; cnt++)
     {
          sprintf (buffer, "");
          _settextposition (cnt, 11);  _outtext (buffer);
          _settextposition (cnt, 70);  _outtext (buffer);
     }
     for (cnt=9; cnt<24; cnt++)
     {
          sprintf (buffer, "                    ");
          _settextposition (cnt, 11);  _outtext (buffer);
          sprintf (buffer, "                                  ");
          _settextposition (cnt, 36);  _outtext (buffer);
     }
     sprintf (buffer, "ͼ");
     _settextposition (24, 11);  _outtext (buffer);
     sprintf (buffer, "");
     _settextposition (5, 12);  _outtext (buffer);
     _settextposition (8, 12);  _outtext (buffer);

     /*--------------------------------*/
     /* Output the Titles and Headings */
     /*--------------------------------*/
     _setbkcolor (0);  _settextcolor (14);
     sprintf (buffer, " BASE 216 CONVERSION ");
     _settextposition (4, 29);  _outtext (buffer);
     _settextcolor (15);  _setbkcolor (3);
     sprintf (buffer, "          ");
     _settextposition (4, 19);  _outtext (buffer);
     sprintf (buffer, " ");
     _settextposition (4, 12);  _outtext (buffer);
     _settextposition (4, 53);  _outtext (buffer);
     _settextposition (4, 69);  _outtext (buffer);
     _setbkcolor (6);
     sprintf (buffer, "     Equivalent Base Numbers    ");
     _settextposition (8, 37);  _outtext (buffer);
     _settextcolor (0);
     sprintf (buffer, " Date ");
     _settextposition (4, 13);  _outtext (buffer);
     sprintf (buffer, " Time          ");
     _settextposition (4, 54);  _outtext (buffer);
     _setbkcolor (7);
     sprintf (buffer, "                Maximum:                                  ");
     _settextposition (6, 12);  _outtext (buffer);
     sprintf (buffer, " Base:           Number:                                  ");
     _settextposition (7, 12);  _outtext (buffer);

     /*-------------------------*/
     /* Output the Base Numbers */
     /*-------------------------*/
     _setbkcolor (1);  _settextcolor (14);
     sprintf (buffer, "  2 ");  _settextposition ( 9, 32);  _outtext (buffer);
     sprintf (buffer, "  3 ");  _settextposition (10, 32);  _outtext (buffer);
     sprintf (buffer, "  4 ");  _settextposition (11, 32);  _outtext (buffer);
     sprintf (buffer, "  5 ");  _settextposition (12, 32);  _outtext (buffer);
     sprintf (buffer, "  6 ");  _settextposition (13, 32);  _outtext (buffer);
     sprintf (buffer, "  7 ");  _settextposition (14, 32);  _outtext (buffer);
     sprintf (buffer, "  8 ");  _settextposition (15, 32);  _outtext (buffer);
     sprintf (buffer, "  9 ");  _settextposition (16, 32);  _outtext (buffer);
     sprintf (buffer, " 10 ");  _settextposition (17, 32);  _outtext (buffer);
     sprintf (buffer, " 11 ");  _settextposition (18, 32);  _outtext (buffer);
     sprintf (buffer, " 12 ");  _settextposition (19, 32);  _outtext (buffer);
     sprintf (buffer, " 13 ");  _settextposition (20, 32);  _outtext (buffer);
     sprintf (buffer, " 14 ");  _settextposition (21, 32);  _outtext (buffer);
     sprintf (buffer, " 15 ");  _settextposition (22, 32);  _outtext (buffer);
     sprintf (buffer, " 16 ");  _settextposition (23, 32);  _outtext (buffer);
}


/*---------------------------------------*/
/* Routine to paint the Message Area Box */
/*---------------------------------------*/
message_area ()
{
     _setbkcolor (7);  _settextcolor (9);

     sprintf (buffer, "Ŀ");
     _settextposition (12, 12);  _outtext (buffer);
     sprintf (buffer, " PROGRAM MESSAGES ");
     _settextposition (13, 12);  _outtext (buffer);
     sprintf (buffer, "ĳ");
     _settextposition (14, 12);  _outtext (buffer);

     sprintf (buffer, "                  ");
     for (lines=15; lines<20; lines++)
     {
          _settextposition (lines, 12);  _outtext (buffer);
     }

     sprintf (buffer, "");
     _settextposition (20, 12);  _outtext (buffer);
}


/*-------------------------------------------------------------------*/
/* Routine to output the Current Date (mm/dd/yy) and Time (hh:mm:ss) */
/*-------------------------------------------------------------------*/
DateTime ()
{
     char date_buf[9];
     char time_buf[9];

     _strdate (date_buf);
     /*--------------------------------*/
     /* Output Current Date - mm/dd/yy */
     /*--------------------------------*/
     sprintf (buffer, "%8s ", date_buf);  _settextposition (4, 19);
     _setbkcolor (6);  _settextcolor (15);  _outtext (buffer);

     _strtime (time_buf);
     /*--------------------------------*/
     /* Output Current Time - hh:mm:ss */
     /*--------------------------------*/
     sprintf (buffer, "%8s ", time_buf);  _settextposition (4, 60);
     _setbkcolor (6);  _settextcolor (15);  _outtext (buffer);
}


/*----------------------------------------------*/
/* Routine to output the Messages (msg1 - msg5) */
/*----------------------------------------------*/
out_message ()
{
     _setbkcolor (7);  _settextcolor (0);
     sprintf (buffer, msg1);  _settextposition (15, 13);  _outtext (buffer);
     sprintf (buffer, msg2);  _settextposition (16, 13);  _outtext (buffer);
     sprintf (buffer, msg3);  _settextposition (17, 13);  _outtext (buffer);
     sprintf (buffer, msg4);  _settextposition (18, 13);  _outtext (buffer);
     sprintf (buffer, msg5);  _settextposition (19, 13);  _outtext (buffer);
     _setbkcolor (3);
}
